#ifndef __CCAMERA_H_
#define __CCAMERA_H_

#include "CBaseEntity.h"
#include "Vec3.h"

//-----------------------------------------------------------
// Class CCamera
//
//	This class serves as a temporary substitute for the player
// in the interval before the game starts, giving us a sweeping
// camera effect of some sort.
//
//-----------------------------------------------------------

class CCamera : public CBaseEntity
{
public:
	// CBaseEntity stuff
	void Spawn();
	void Think();

	// initialization for the camera types
	void InitOverlook();
	void InitStarter();
	
	int camState; // what state is the camera in?
	int camType; // what type of camera is this?
	Vec3d targOrigin; // what origin are we slated to end up at?
	Vec3d targOrientation; // NOT USED
	float camTime; // how long is the camera in use for?
	float camEndTime; // when will the camera end?
};

#endif