
#ifndef __CMENUCONTROL_H_
#define __CMENUCONTROL_H_

#include "IHighScores.h"

//-----------------------------------------------------------
// Class CMenuControl
//
//	This class controls the menu that comes before the game,
// allowing the player to choose what he/she wants to do.
//
//
//	UPDATES:
//	4/2/04 - Daniel: created
//	4/21/04 - Daniel: finished
//
//-----------------------------------------------------------


class CMenuControl
{
public:
	CMenuControl();

	void UpdateInputCommands();

	void Think(); // main call everyframe
	void IntroThink();
	void SelectThink();
	void GameSelectThink();
	void HighScoresThink();
	void TrainingThink();
	int GetSoundFromMenuSelect();
	
	// timers
	float timerTransition;	// when to start the next menu mode
	float timerReminder;	// when to remind the play what they're selecting
	float timerNum;			// when to say the number they're selecting 
	float timerScores;		// when the scores is finished being said
	float timerTrainingDone; // when the training is finished
	// input timers
	float timerNextUp;
	float timerNextDown;
	float timerNextRight;
	float timerNextLeft;
	float timerNextBack;
	float timerNextConfirm;
	

	bool bUp, bDown, bLeft, bRight, bBack, bConfirm; // input bools
	int levelStart; // what level are we set to start on?
	int menuState; // main menu state
	int menuMainSelect; // which part of the menu are we currently selecting?
	bool bTrainingPlaying; // have we started the training song yet?

	bool bSaidInstructions;

	IHighScores *m_pHighScores; // for viewing high scores
};


#endif