
#ifndef __CUBERCONTROL_H_
#define __CUBERCONTROL_H_

#include "CGameControl.h"
#include "CMenuControl.h"

//-----------------------------------------------------------
// Class CUberControl
//
//	This class controls the menu system and the game system, deciding
// which should control the program at any given time.
//
//	UPDATES:
//	2/9/04 - Daniel: created, first pass, basic skeleton
//	2/13/04 - Daniel: LaunchGame
//
//-----------------------------------------------------------

class CUberControl
{
public:
	CUberControl();
	void Think();		// call the logic of either the game or the menu every frame
	void Draw();
	void LaunchGame(); // initiate gameControl/switch to it
	void LaunchMenu();	// initiate menuControl/switch to it
	void CleanupGame();	// free game-associated memory
	void CleanupMenu();	// free menu-associated memory
	void CheckGame();	// check game state every frame
	void CheckMenu();	// check menu state every frame
	
	CGameControl* gameControl;		// our game object
	CMenuControl* menuControl;		// our menu object
	int exState;					// our ubercontrol state
	int gameStartLevel;	
};


#endif