
#ifndef __IFILEIO_H_
#define __IFILEIO_H_

#include <fstream>
#include <vector>
#include <sstream>
#include <stdlib.h>
#include <string>
using namespace std;

//--------------------------------------------------------
//	Class IFileIO
//
// This class serves as a wrapper over whatever file input
// code exists for the compiler/os.
//
//	UPDATES:
//	2/9/04, Daniel: very rough outline. take it away
//	2/17/04, Matt: First draft. After many tries, finally figured out
//					the best way to split up line into words and how
//					to pass it along.
//	3/24/04, Matt: added default constructor and added OpenFile function
//
//--------------------------------------------------------



/* UPDATE (Matt) 2/17/04

IFileIO:
Right now only contains three functions: ReadLine(), isFileEnded(), and 
CloseFile().  The constructor automatically opens the file, so the filepath
must be predetermined (I can add a default constructor if this is not going
to be the case). isFileEnded() and CloseFile() are very simple, they just call
the concurrent functions in fstream. ReadLine()is the main function of IFileIO.
It reads the first line of the input text file. It then uses a simple tokenizer
to break up the string into words, placing them into a vector<string>, and returns
the vector. The next call of ReadLine() automatically reads the next line, so 
NextLine() is not needed.
*/

class IFileIO
{
public:
	
	// constructors
	IFileIO();
	IFileIO( string filePath );

	void OpenFile( string filePath ); 
	// returns vector of strings
	// if at end of file, return null pointer.
	vector<string> ReadLine(); 
	
	bool isFileEnded(); // did we reach the end, used in while()
	void CloseFile();	// closes file stream
	

	
protected:
	ifstream f;				// Input file stream
};





#endif