#ifndef __IINPUT_H_
#define __IINPUT_H_

//-----------------------------------------------------------
// Class IInput
//
//	This class keeps track of whether a key is pressed down
//	or not.
//
//
//	UPDATES:
//	2/14/04 - Daniel: created
//	2/18/04	- Matt: first draft (in console base)
//				-made program wait for input, which was not desirable
//				-also, group decided to move to windows based application
//	2/22/04 - Matt: winbase first draft completed
//
//-----------------------------------------------------------

const int GKEY_UP		= 1;
const int GKEY_DOWN		= 2;
const int GKEY_LEFT		= 3;
const int GKEY_RIGHT	= 4;
const int GKEY_ESC		= 5;
const int GKEY_SPACE	= 6;

const int NUM_KEYS		= 6;	//total number of inputs allowed



class IInput
{
public:

	IInput();
	void pressDown( int key );
	void pressUp( int key );
	// do not change the interface to this
	bool isKeyPressed( int key );

protected:
	bool listOfKeys[NUM_KEYS];		//Stores boolean values of whether a key is
									//pressed. Each key constant above corresponds
									//to the entry [key-1] in the array (i.e. GKEY_UP
									//maps to listOfKeys[0], etc.)
};


#endif