
#ifndef __IRAND_H_
#define __IRAND_H_

#include <cstdlib>
#include "CBaseEntity.h"
#include "ITime.h"

//-------------------------------------
//	Class IRand
//
// ... because rand() returns the same sequence of 
// numbers every time, it's necessary to get an ACTUAL
// random number, which we do by getting the raw time
// and mixing it into the equation.
//
//	UPDATES:
//		- 2/18/04, Daniel: created, appears to work.
//
//-------------------------------------

class IRand
{
public:
	int Rand() 
	{
		int i = rand(); // get a 'random' integer
		int time = (int)glTime->getRaw(); // returns the second count
		
		if ( i >= time )
			return i % time; // now you don't know WHERE we're coming from
		else
			return time % i; // that's the essence of randomosity
	}
};

#endif