
#ifndef __ITIME_H_
#define __ITIME_H_

//#include <windows.h>
#include <afxwin.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "globalconst.h"

//-------------------------------------
//	Class ITime
//
// ... keeps a timer for the entire game, rather than
// having to repeat this code every time you need to 
// time something. 
//
//	UPDATES:
//		- 2/8/04, Daniel: Created--hope this works
//		- 2/11/04, Daniel: lastFrame implementation
//		- 2/18/04, Daniel: getRaw, for the random number generator
//		- 3/18/04, Daniel: changed everything to use GetTickCount from windows instead of clock_t stuff
//
//-------------------------------------

// NOTE - this code used to keep its own time, but after the Direct3D switchover, it made more sense to 
// update the frame externally

class ITime 
{
public:
	float getTime() { return time; }
	float getRaw() { return (float)GetTickCount(); }
	float getLastFrameTime() { return time-elapsedTime; }

	float reportFrameInterval() { return elapsedTime; }
	
	// This is dependent on direct X's time functions
	void DXFrameUpdate( float neoTime, float neoInterval )
	{
		time = neoTime;
		elapsedTime = neoInterval;
	}

protected:
	float time; // what time is it?
	float elapsedTime;	// how much time elapsed since the last frame?
	
};


#endif