#include "OFileIO.h"

//-----------------------------------------------------------
// OFileIO - functions definitions
//
//	... see header for more information
//
//
//	UPDATES:
//	3/25/04 - Matt: created 
//
//-----------------------------------------------------------


//Default constructor
//
OFileIO::OFileIO()
{
}

//Constructor with filePath
//
//
OFileIO::OFileIO(string filePath)
{
	o.open(filePath.c_str());	//opens filePath

	//test for error when opening filePath
	if(!o)							
	{
		//usually put a return 0 here, but function is void, so had
		//to use abort()-- this function is not really necessary
		abort();		//aborts program if there was error opening file
	}
}

//
// OpenFile
//	... called by: any
//	... description: opens filePath to be read to
void OFileIO::OpenFile(string filePath)
{
	//opens filePath
	o.open(filePath.c_str());	

	if(!o)							
	{
		abort();		
	}
}

//
// WriteLine
//	... called by: any
//	... description: writes line to opened filePath
void OFileIO::WriteLine(string line)
{
	o << line << endl;
}

//CloseFile
//	... called by: any
//	... description: closes file
void OFileIO::CloseFile()
{
	o.close();
}


