
#ifndef __OFILEIO_H_
#define __OFILEIO_H_

#include <fstream>
#include <string>
using namespace std;

//--------------------------------------------------------
//	Class OFileIO
//
// This class serves as a wrapper over whatever file output 
// code exists for the compiler/os. Complement to IFileIO.
//
//	UPDATES:
//	3/25/04 - Matt: Created	
//		
//--------------------------------------------------------

class OFileIO
{
public:
	
	// default constructor
	OFileIO();		
	// constructor with filePath provided
	OFileIO( string filePath );    

	void OpenFile( string filePath ); // open file to be read to
										
	void WriteLine(string line); // write line to file
						

	void CloseFile();	// closes file stream
	

	
protected:
	ofstream o;				// output file stream
};





#endif