
#ifndef __GLOBALCONST_H_
#define __GLOBALCONST_H_


//-------------------------------------
//	global constants
//
// ... coded by everyone, as needed
//
//	UPDATES:
//		- 2/9/04, Daniel: created; tracks, nextthinks, some SNDs
//
//-------------------------------------


//
const bool IS_DEBUG				= false;

// pi
const float PI = (float)3.14159265358979323846; // is this too many digits?

// highest level you can start at
const int LEVEL_START_HIGH = 20;

// for strings
const int LINE_ARRAY_LENGTH		= 5;
const float MAX_DRAW_DIST		= 1000;

// operators

// radii
const float RADIUS_COIN			= 3;
const float RADIUS_OBSTACLE		= 2;
const float RADIUS_PLAYER		= 3;

// heigh differentials
const float COIN_OFFSET			= -2.0;

// lives
const int NUM_LIVES_STANDARD	= 3;

// tracks
const float TRACK_1_X			= 10;
const float TRACK_2_X			= 0;
const float TRACK_3_X			= -10;

// level length
const int LEVEL_LINE_MIN		= 300;

// level line separation
const float LINE_SEPARATION		= 10;
const float SEGMENT_SEPARATION	= LINE_SEPARATION*2;

// speed
//const float MAX_PLAYER_SPEED	= 100;	// floatingpts/sec
//const float MIN_PLAYER_SPEED	= 30;
const float MAX_PLAYER_SPEED	= 100;	// floatingpts/sec
const float MIN_PLAYER_SPEED	= 30;
const float SPEED_INTERVALS		= 3.0f; // floatingpts/sec

// intervals
const float MENU_INTERVAL_MOVE			= (float)0.25;
const float MENU_INTERVAL_CHOOSE		= (float)0.5;
const float MENU_INTERVAL_TRANSITION	= (float)1.0f;
const float MENU_INTERVAL_REMINDER		= 5.0f;
const float MENU_INTERVAL_NUM			= 0.3f;
const float MENU_INTERVAL_SONICZOOM		= 1.6f;

const float ACCEL_TIME			= 3; // seconds
const float STUN_TIME_STANDARD	= 3; // seconds
const float TIME_TILL_START		= 3;
const float FRAME_INTERVAL		= (float)0.033; // 60 fps
const float SWITCH_INTERVAL		= (float)0.15;

const float GAME_TIMER_BACK		= 0.15f;
const float GAME_TIMER_CONFIRM	= 0.4f;
const float GAME_TIMER_RIGHTLEFT = 0.15f;
const float GAME_TIMER_UPDOWN	= 0.15f;
const float GAME_TIMER_LETTER	= 5.0f;

const float GAME_TIMER_SAYSCORE = 3.5f;

const float GAME_TIMER_DEATHREMIND = 7.0f;
const float GAME_TIMER_DEATHTRANS = 2.0f;

// next think intervals
const float NT_COIN				= (float)0.1;
const float NT_PLAYER			= (float)0.1;
const float NT_OBSTACLE			= (float)0.1;

// scoring
const int SCORE_PER_COIN			= 10;
const float SCORE_MULTIPLIER_RANGE	= 3.0f;




#endif