
#ifndef __ISCRIPTSEGMENT_H_
#define __ISCRIPTSEGMENT_H_

#include "IScriptLine.h"

//-----------------------------------------------------------
// Class IScriptSegment
//
//	This class represents the segments of each level to be
// randomly put together.
//
//
//	UPDATES:
//	2/16/04/ - Daniel: created
//
//-----------------------------------------------------------

class IScriptSegment
{
public:
	// functions
	IScriptSegment( ); // constructor
	void Cleanup();	// memory cleanup
	void AddLine( IScriptLine * s ); // add a line to the array
	void IncreaseCap();	// increase the capacity of the array

	int difficulty;		// difficulty of this segment
	int lineCount;		// number of lines in the array
	int capacity;		// the capacity of the array
	IScriptLine **lineArray; // pointer to the array
};

#endif