#ifndef __ITEXTTOSPEECH_H_
#define __ITEXTTOSPEECH_H_

//#define _WIN32_DCOM 
/*
#ifdef _WINDOWS_
#error WINDOWS DEFINED HERE1
#endif
*/
#include <afxwin.h> // THESE TWO MUST GO IN THIS ORDER
#include <sapi.h> // AFTERWARDS, WINDOWS WILL BE DEFINED, WHICH AFX HATES, BUT THE INCLUDES ARE ONLY DONE ONCE SO IT MATTERS NOT
#include <string>

using namespace std;



//-----------------------------------------------------------
// Class ITextToSpeech
//
//	This class (using Microsoft SDK 5.1) performs the 
//  text-to-speech requirements of the game. The important function
//  is speakText(), which takes a string as a parameter and 
//  "speaks" that string. 
//
//
//	UPDATES:
//	2/22/04 - Matt: created
//	2/29/04	- Matt: simple "Hello World" using Text-to-Speech created
//	3/02/04 - Matt: tested numerous ways for the program to "speak" 
//					strings that are given to the class as parameters
//	3/04/04 - Matt: tested the capability of the Speak() function to 
//					read text files
//	3/14/04 - Matt: created first draft
//					- strings that were passed to ITextToSpeech were sent to a
//						file, which was then read back by the Speak() function
//					- this was cumbersome, but there was no way for the Speak()
//						function to take simple strings as parameters
//	3/21/04 - Matt: created 2nd draft
//					- figured out how to use CString class, so Speak() function
//						could now take a string as a parameter instead of a file
//					- All functions are contained in this ITextToSpeech.h file 
//						because when I split this up into .h and .cpp, it would
//						not compile
//  3/24/04 - Matt: split ITextToSpeech into a .h and a .cpp file (got the linking 
//					bug to work by adding '/FORCE:MULTIPLE' to the Linker
//					Command Line in the project properties)
//
//-----------------------------------------------------------



class ITextToSpeech
{
public:
	ITextToSpeech();				//Constructor
	bool speakText(string text);
};






#endif