
#ifndef __CPLAYER_H_
#define __CPLAYER_H_

#include "CBaseEntity.h"
#include "stateflagdefs.h"
#include "globalconst.h"


//-----------------------------------------------------------
// Class CPlayer
//
//	This class represents and controls the player, which is the 
// most (arguably only) dynamic element in the game. It has its 
// own states to manage, and handles input also.
//
//
//	UPDATES:
//	2/11/04 - Daniel: created, first pass
//	3/15/04 - Daniel: SwitchBegin, HandleInput, floats/ints
//	4/13/04 - Daniel: level, timer
//
//-----------------------------------------------------------

class CPlayer : public CBaseEntity
{
public:
	CPlayer();

	// main overrided functions
	void Spawn();
	void Think();
	void Hit( CBaseEntity *victim );
	void Remove();
	bool isPlayer() { return true; }
	void SwitchBegin();
	void SwitchCheck();
	void HandleInput();
	
	// what level are we on?
	int level;
	
	// player-specific, non-entvar data
	int lives;
	int coins;
	float lowSpeed;
	float highSpeed;
	float stunnedTime;

	float switchInitialLane;
	float switchDestinationLane;
	float switchOldSpeed;

	float timerLastSwitchEnd;

};



#endif