
#ifndef __CUBERCONTROL_H_
#define __CUBERCONTROL_H_

#include "CGameControl.h"
#include "CMenuControl.h"

//-----------------------------------------------------------
// Class CUberControl
//
//	This class controls the menu system and the game system, deciding
// which should control the program at any given time.
//
//	UPDATES:
//	2/9/04 - Daniel: created, first pass, basic skeleton
//	2/13/04 - Daniel: LaunchGame
//
//-----------------------------------------------------------

class CUberControl
{
public:
	CUberControl();
	void Think();
	void Draw();
	void LaunchGame();
	void LaunchMenu();
	void CleanupGame();
	void CleanupMenu();
	void CheckGame();
	void CheckMenu();
	
	CGameControl* gameControl;
	CMenuControl* menuControl;
	int exState;
	int gameStartLevel;
};


#endif