#include "IFileIO.h"

//-----------------------------------------------------------
// IFileIO - functions definitions
//
//	... see header for more information
//
//
//	UPDATES:
//	3/24/04 - Matt: created (decided it would be better
//					programming to split IFileIO into a .h
//					and a .cpp)
//  3/24/04, Matt: added default constructor and added OpenFile function
//
//-----------------------------------------------------------


//Default Constructor
IFileIO::IFileIO()
{
	
}
//
//Constructor
//
//Opens specified file, tests for error, and creates object IFileIO

IFileIO :: IFileIO( string filePath )
{
	
	f.open(filePath.c_str());	//opens filePath

	if(!f)							//test for error when opening filePath
	{
		//cout << "Error open file " << filePath << " for writing\n";
			abort();		//aborts program if there was error opening file
	}

}

//OpenFile
//
//
void IFileIO :: OpenFile( string filePath )
{
	f.open(filePath.c_str());	//opens filePath

	if(!f)							//test for error when opening filePath
	{
		//cout << "Error open file " << filePath << " for writing\n";
			abort();		//aborts program if there was error opening file
	}
}
//
//ReadLine()
//
//Reads the current line of the input text file. It then uses a simple tokenizer
//to break up the string into words, placing them into a vector<string>, and returns
//the vector. The next call of ReadLine() automatically reads the next line.
//

vector<string> IFileIO :: ReadLine()
{
	string line;				
	
	if (!f.eof())
	{	
		getline(f, line);

	//while (getline(f, line) )	//gets current line of input file (if not at end of file)
	//{
		string buf;				// Buffer string for tokenizer
	    stringstream ss(line);	// Insert line into a stream

		vector<string> tokens;	// Create vector to hold words in line

	    while (ss >> buf)		//tokenizes line into words and adds them to tokens
		    tokens.push_back(buf);
	
	
		return tokens;

	}
	
}


//WriteLine
//
//
//void IFileIO :: WriteLine(string line)



//
//isFileEnded()
//
//Returns true if file is at the end, false otherwise.
//

bool IFileIO :: isFileEnded()
{
	if (f.eof())
		return true;
	else
		return false;

}

//
//CloseFile()
//
//Closes file stream.
//

void IFileIO :: CloseFile()
{
	f.close();
}