
#ifndef __IFILEIO_H_
#define __IFILEIO_H_

// REPLACE "string" below with whatever it is that you use
//typedef string IString; // or maybe just use String for now

//--------------------------------------------------------
//	Class IFileIO
//
// Serves as a wrapper over whatever file i/o code exists
// for the compiler/os.
//
//	UPDATES:
//		- 2/9/04, Daniel: very rough outline. take it away
//		- 2/17/04, Matt: First draft. After many tries, finally figured out
//					the best way to split up line into words and how
//					to pass it along.
//		- 3/24/04, Matt: added default constructor and added OpenFile function
//
//--------------------------------------------------------

// MEMO TO MATT:
/*
	There's a levelalpha.txt that shows the initial format we're going for.
The script language pretty much consists of keywords separated by spaces.
So what we need is to be able to store a set of C/IScriptSegment objects 
from which a level can be created. To do this, it would be best to have some sort
of array in each, with lines made up of a set of Strings. For instance, when
loading we could go to the first line, check the first String, see that it's 
a "segment" keyword, then check the second to see what the segment_id is. At other times,
the first String would be "line" and the second, third, and fourth Strings would be
either blank, a coin, or an obstacle.

The question is, how do we store that data? Each line has a variable number of Strings...
How do we break it up into the different keywords from each line?

You'll have to figure out the latter, but I'm tentatively okay with just having a
two-dimensional array of pointers to Strings, or something, with the amount of Strings in
each line having some maximum value (like 5, and we just don't use the extra ones).

When the game is started, transitioning from the menu, we create an ILevelLoader object
that opens a file containing our level information. This file keeps the set of IScriptSegment
objects. When we go to actually load a level, ILevelLoader::Generate() gets called with, based 
on the level number/difficulty, turns the IScriptSegment objects into an array of entities that
make up the actual game.

UPDATE: The below "for alpha" definitions should be good to go. I've actually started working on
ILevelLoader::Load, you can check it out

UPDATE: Jesus Christ, never mind. I'm changing how it works every time I look at it. At the moment,
I'm parsing stuff in ILevelLoader::Load and turning into IScriptLines, which together make up 
IScriptSegments
 
*/

/* UPDATE (Matt) 2/17/04

IFileIO:
Right now only contains three functions: ReadLine(), isFileEnded(), and 
CloseFile().  The constructor automatically opens the file, so the filepath
must be predetermined (I can add a default constructor if this is not going
to be the case). isFileEnded() and CloseFile() are very simple, they just call
the concurrent functions in fstream. ReadLine()is the main function of IFileIO.
It reads the first line of the input text file. It then uses a simple tokenizer
to break up the string into words, placing them into a vector<string>, and returns
the vector. The next call of ReadLine() automatically reads the next line, so 
NextLine() is not needed.
*/



#include <fstream>
#include <vector>
#include <sstream>
#include <stdlib.h>

#include <string>
using namespace std;



class IFileIO
{
public:
	// initializations

	// FOR ALPHA:
	IFileIO( string filePath );

	IFileIO();

	void OpenFile( string filePath ); // open this file -- NOT NEEDED unless
										// filepath is not known beforehand
	vector<string> ReadLine(); // returns vector of strings
							// if at end of file, return null pointer.
	//void NextLine(); // skip to next line -- NOT NEEDED
	bool isFileEnded(); // did we reach the end, used in while()
	void CloseFile();	// closes file stream
	
	
	
	// write line
	//	String * ReadLine(int i);
	//void WriteLine( string line );
	// write indexed line
	//void WriteLine( String& line, int i );

	
protected:
	ifstream f;				//Input file stream
};





#endif