#include "IInput.h"

//-----------------------------------------------------------
// IInput - functions definitions
//
//	... see header for more information
//
//
//	UPDATES:
//	2/14/04 - Daniel: created
//	2/18/04	- Matt: first draft (in console base)
//				-made program wait for input, which was not desirable
//				-also, group decided to move to windows based application
//	2/22/04 - Matt: winbase first draft completed
//
//-----------------------------------------------------------



//Constructor
//
//Initializes entries of listOfKeys to false.
//
IInput :: IInput()
{
	for (int i = 0; i < NUM_KEYS; i++)
		listOfKeys[i] = false;
}


//pressDown
//
//Changes entry in listOfKeys that corresponds to key to true.
//(That key is currently pressed down.)
//
void IInput :: pressDown( int key )
{
	listOfKeys[key-1] = true;
}

//pressUp
//
//Changes entry in listOfKeys that corresponds to key to false.
//(That key is currently not pressed down.)
//
void IInput :: pressUp( int key )
{
	listOfKeys[key-1] = false;
}

//isKeyPressed
//
//Takes integer "key" that relates to the 4 arrow keys and ESC 
//(see IInput.h for constants).
//
//Returns entry in listOfKeys that corresponds to key (also checks to
//see if key is within the allowed range) 
//**********NEED TO CHANGE RANGE IF MORE KEY CONSTANTS ARE ADDED***********
//
bool IInput :: isKeyPressed( int key )
{
    if ( (key <= NUM_KEYS) && (key >= 1) )
	{
		if ( listOfKeys[key-1] == false )
			return false;
		else if ( listOfKeys[key-1] == true )
		{
			//listOfKeys[key-1] = false;
			return true;
		}
	}
	else
	{
		return false;
	}
}


