
#ifndef __ILEVELLOADER_H_
#define __ILEVELLOADER_H_

#include "globalconst.h"
#include "CBaseEntity.h"
#include "IEntVars.h"
#include "IScriptSegment.h"

//-----------------------------------------------------------
// Class ILevelLoader
//
//	This class handles the level database and is used both to 
// load the level file and to generate levels.
//
//
//	UPDATES:
//	2/14/04 - Daniel: created
//	2/16/04	- Daniel: Load(), first pass
//
//-----------------------------------------------------------

class ILevelLoader
{
public:
	ILevelLoader(); // constructor
	void Cleanup();

	CBaseEntity**	Generate( int level ); // generate from segments, based on level number
	int				GetDifficultyFromLevel( int level );
	void			Load(); // load from file
	bool			isLoaded(); // have we loaded it?
	int				getEntCount(); // AFTER generated
	void			AddSeg( IScriptSegment* seg ); // add a segment to the array
	void			IncreaseSegCap(); // increase the array capacity
	float			getZEnd(); // returns zEnd
	



protected:
	bool			bLoaded; // have we loaded it?
	int				genEntCount; // if we have, how many were there?

	int				segCount; // how many segments in array?
	int				capacity; // how much array capacity?
	float			zEnd; // z value at the end of the track
	IScriptSegment **segArray; // pointer to an array of pointers to IScriptSegments

};

#endif