
#include "ITextToSpeech.h"

//-----------------------------------------------------------
// ITextToSpeech - functions definitions
//
//	... see header for more information
//
//
//	UPDATES:
//	3/24/04 - Matt: created (got the linking bug to work--
//					had to add '/FORCE:MULTIPLE' to the Linker
//					Command Line in the project properties since 
//					it was previously giving linking errors)
//  3/29/04 - Matt: changed CoInitialize to CoInitializeEx
//	4/2/04 - Daniel: added this atl stuff below to get it to compile,
//					changed CoInitializeEx to CoInitialize (HRESULT was failing)
//
//-----------------------------------------------------------


//#define _ATL_APARTMENT_THREADED

#include <atlbase.h>
//You may derive a class from CComModule and use it if you want to override something, 
//but do not change the name of _Module
extern CComModule _Module;
#include <atlcom.h>

//Constructor
//
//Does nothing, allows declaration of ITextToSpeech object.
//

ITextToSpeech::ITextToSpeech()
{
}

//speakText
//
//Parameter: string text
//
//This function takes the string and speaks it. If
//initialization fails, it returns false. Otherwise,
//the text is spoken and returns true.
//
bool ITextToSpeech::speakText(string text)
{
	ISpVoice * pVoice = NULL;			

   /* if (FAILED(::CoInitializeEx(NULL,0)))			//initialize COM
        return false;
		*/
	if ( FAILED(::CoInitialize(NULL)))
		return false;
	
	//sets up the default voice (a COM object)
   HRESULT hr = CoCreateInstance(CLSID_SpVoice, NULL, CLSCTX_ALL, IID_ISpVoice, (void **)&pVoice);
   if( SUCCEEDED( hr ) )
    {
     		
		CString cText;					
		cText.Format("%s",text.c_str());			//converts string text to CString
		hr = pVoice->Speak(cText.AllocSysString(),0,NULL);		//speaks the CString

		
		pVoice->Release();					//releases the pointer	
        pVoice = NULL;
    }


	::CoUninitialize();						//uninitializes COM
    return true;

}
