
#ifndef __ITIME_H_
#define __ITIME_H_

//#include <windows.h>
#include <afxwin.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "globalconst.h"

//-------------------------------------
//	Class ITime
//
// ... keeps a timer for the entire game, rather than
// having to repeat this code every time you need to 
// time something. 
//
//	UPDATES:
//		- 2/8/04, Daniel: Created--hope this works
//		- 2/11/04, Daniel: lastFrame implementation
//		- 2/18/04, Daniel: getRaw, for the random number generator
//		- 3/18/04, Daniel: changed everything to use GetTickCount from windows instead of clock_t stuff
//
//-------------------------------------
/*
class ITime 
{
public:
	ITime() { start = clock(); bActivated = true; }
	float getTime() { return (float)(clock()-start)/CLK_TCK; }
	void frameUpdate() { secLastFrame = lastFrame; lastFrame = getTime(); }
	float getRaw() { return (float)clock(); }


	float getLastFrameTime() 
	{ 
		if ( !bActivated )
		{
			bActivated = true;
			return (getTime() - (lastFrame-secLastFrame));
		}
		return lastFrame; 
	}


	bool bActivated;
protected:
	clock_t start; // starting time for clock initialization
	float lastFrame;
	float secLastFrame; // for freezes
	
};
*/

class ITime 
{
public:
	ITime() 
	{ 
		start = (float)(getRaw() * 0.001); 
		bActivated = true; 
	}

	float getTime() 
	{ 
		return time;
		//return (float)(getRaw() * 0.001);
	}

	void frameUpdate() 
	{ 
		secLastFrame = lastFrame; 
		lastFrame = getTime(); 
		time = (float)(getRaw() * 0.001);
	}
	
	float getRaw() 
	{ 
		return (float)GetTickCount(); 
	}


	float getLastFrameTime() 
	{ 
		/*
		if ( !bActivated )
		{
			bActivated = true;
			return (getTime() - (lastFrame-secLastFrame)); 
		}
		return lastFrame; 
		*/

		return time-elapsedTime;
	}

	float reportFrameInterval()
	{
		//return lastFrame-secLastFrame;
		return elapsedTime;
	}
	
	// directx
	void DXFrameUpdate( float neoTime, float neoInterval )
	{
		time = neoTime;
		elapsedTime = neoInterval;
	}

	// directx
	void DXSetStart( float dxstart )
	{
		start = dxstart;
	}


	bool bActivated;
protected:
	float start; // starting time for clock initialization
	float lastFrame;
	float secLastFrame; // for freezes
	
	float time;
	float elapsedTime;
	
};


#endif