
#ifndef __OFILEIO_H_
#define __OFILEIO_H_


//--------------------------------------------------------
//	Class OFileIO
//
// Serves as a wrapper over whatever file i/o code exists
// for the compiler/os. Complement to IFileIO.
//
//	UPDATES:
//		- 3/25/04, Matt: Created	
//		
//--------------------------------------------------------




#include <fstream>


#include <string>
using namespace std;



class OFileIO
{
public:
	
	OFileIO();		//Default constructor

	OFileIO( string filePath );    //constructor with filePath provided



	void OpenFile( string filePath ); // open file to be read to
										
	void WriteLine(string line); // write line to file
						

	void CloseFile();	// closes file stream
	

	
protected:
	ofstream o;				//Output file stream
};





#endif