#include "glfunc.h"
#include "windows.h"
#include <gl/gl.h>
#include <gl/glu.h>
//#include "../gl/GL.h"
//#include "../gl/GLU.h"
#include <stdio.h>
#include <stdlib.h>
#include "glaux.h"
#include "IRand.h"
#include "CBaseEntity.h"

extern IRand* glRand;



// -------------------------------------
// glfunc - functions definitions
//
// ... see header for more information
//
//	UPDATES:
//		- 2/22/2004 - Patrick started this class
//      - 2/24/2004 - Patrick finished this class
// 
//	
// -------------------------------------

GTrackArray *glTrack;
const float FRAC = 0.001;
const float RANGE = 60;
const float LOOK_AHEAD = 30;
static int rotate = 0;
GLuint	base;				// Base Display List For The Font Set
HDC			glhDC=NULL;		// Private GDI Device Context

//the class constructor
glfunc :: glfunc (){

}

void glfunc :: init()
{
    //use this color when clearing frame buffer
	glClearColor(0.0, 0.0, 0.6, 0.0);
	
}


//function that draws obstacles
void glfunc :: drawCoin(float x, float width, float height, float z, float depth){

	glColor3f(1.0f, 1.0f, 0.0f);
	//coin is a basic cube for right now
//	float angle = glTrack->getRotationFromXYZ(x,0,z,RANGE,FRAC);
	//angle = (angle/(2*PI))*360;
	//glRotatef(angle,0.0f,0.0f,1.0f);
	

	glBegin(GL_QUADS);  //draw front face of cube
		glVertex3f(x - (width/2.0f), height, z);
		glVertex3f(x - (width/2.0f), height + 0.3f, z);
		glVertex3f(x + (width/2.0f), height + 0.3f, z);
		glVertex3f(x + (width/2.0f), height, z);	
	glEnd(); 

	
	glBegin(GL_QUADS);  //draw left side of cube
		glVertex3f(x - (width/2.0f), height, z);
		glVertex3f(x - (width/2.0f), height, z + depth);
		glVertex3f(x - (width/2.0f), height + .3f, z + depth);
		glVertex3f(x - (width/2.0f), height + .3f, z);	
	glEnd(); 

	glBegin(GL_QUADS);  //draw right side of cube
		glVertex3f(x + (width/2.0f), height, z);
		glVertex3f(x + (width/2.0f), height, z + depth);
		glVertex3f(x + (width/2.0f), height + .3f, z + depth);
		glVertex3f(x + (width/2.0f), height + .3f, z);	
	glEnd(); 

	glBegin(GL_QUADS);  //draw bottom of cube
		glVertex3f(x - (width/2.0f), height, z);
		glVertex3f(x - (width/2.0f), height, z + depth);
		glVertex3f(x + (width/2.0f), height, z + depth);
		glVertex3f(x + (width/2.0f), height, z);	
	glEnd(); 

	glBegin(GL_QUADS);  //draw top of cube
		glVertex3f(x - (width/2.0f), height + .3f, z);
		glVertex3f(x - (width/2.0f), height + .3f, z + depth);
		glVertex3f(x + (width/2.0f), height + .3f, z + depth);
		glVertex3f(x + (width/2.0f), height + .3f, z);	
	glEnd();
	

}

const float OBSTACLE_HEIGHT = 5; // was 0.4f
//function that draws obstacles
void glfunc :: drawObstacle(float x, float width, float height, float z, float depth){
	
	//glColor3f(1, 0, 0);
	//obstacle is a basic cube for right now

	glColor3f(1.0, 0, 0);
/*
	GLUquadricObj *pObj = gluNewQuadric();	// create a quadric

	//draw the coin at the right place
	glPushMatrix();
    	glTranslatef(x, height, z);
		gluSphere(pObj, 2.0f, 20, 20);
	glPopMatrix();

	gluDeleteQuadric(pObj); // delete the quadric

	float xMine = 1.35f;
	float yMine = 1.35f;
	float zMine = 1.15f;
	//draw the spheres on the mine
	glColor3f(.3, .3, .3);
	GLUquadricObj *pObj1 = gluNewQuadric();	// create a quadric
	glPushMatrix();
		glTranslatef(x, height, z - zMine);
	//	glRotatef(rotate, 0, 0, 1);
		glTranslatef(-x, -height, -z + zMine);
		glTranslatef(x - xMine, height - yMine, z - zMine);
		gluSphere(pObj1, .5f, 20, 20);
	glPopMatrix();
	gluDeleteQuadric(pObj1); // delete the quadric

	glColor3f(.3, .3, .3);
	GLUquadricObj *pObj2 = gluNewQuadric();	// create a quadric
	glPushMatrix();
		glTranslatef(x, height, z - zMine);
	//	glRotatef(rotate, 0, 0, 1);
		glTranslatef(-x, -height, -z + zMine);
		glTranslatef(x + xMine, height - yMine, z - zMine);
		gluSphere(pObj2, .5f, 20, 20);
	glPopMatrix();
	gluDeleteQuadric(pObj2); // delete the quadric
	glColor3f(.3, .3, .3);
	GLUquadricObj *pObj3 = gluNewQuadric();	// create a quadric
	glPushMatrix();
		glTranslatef(x, height, z - zMine);
	//	glRotatef(rotate, 0, 0, 1);
		glTranslatef(-x, -height, -z + zMine);
		glTranslatef(x + xMine, height + yMine, z - zMine);
		gluSphere(pObj3, .5f, 20, 20);
	glPopMatrix();
	gluDeleteQuadric(pObj3); // delete the quadric

	glColor3f(.3, .3, .3);
	GLUquadricObj *pObj4 = gluNewQuadric();	// create a quadric
	glPushMatrix();
		glTranslatef(x, height, z - zMine);
	//	glRotatef(rotate, 0, 0, 1);
		glTranslatef(-x, -height, -z + zMine);
		glTranslatef(x - xMine, height + yMine, z - zMine);
		gluSphere(pObj4, .5f, 20, 20);
	glPopMatrix();
	gluDeleteQuadric(pObj4); // delete the quadric

	rotate++;
*/
/*
	glTranslatef(x,0.0f,z);
	glBegin(GL_QUADS);  //draw front face of cube
		glVertex3f(0.0f, 0.0f, 0.0f);
		glVertex3f(1.0f, 0.0f, 0.0f);
		glVertex3f(1.0f, 1.0f, 0.0f);
		glVertex3f(0.0f, 1.0f, 0.0f);
	glEnd(); 

	glBegin(GL_QUADS);  //draw back face of cube
		glVertex3f(0.0f, 0.0f, 1.0f);
		glVertex3f(1.0f, 0.0f, 1.0f);
		glVertex3f(1.0f, 1.0f, 1.0f);
		glVertex3f(0.0f, 1.0f, 1.0f);
	glEnd(); 

	glBegin(GL_QUADS);  //draw left face of cube
		glVertex3f(0.0f, 0.0f, 0.0f);
		glVertex3f(0.0f, 0.0f, 1.0f);
		glVertex3f(0.0f, 1.0f, 1.0f);
		glVertex3f(0.0f, 1.0f, 0.0f);
	glEnd(); 

	glBegin(GL_QUADS);  //draw right face of cube
		glVertex3f(1.0f, 0.0f, 0.0f);
		glVertex3f(1.0f, 0.0f, 1.0f);
		glVertex3f(1.0f, 1.0f, 1.0f);
		glVertex3f(1.0f, 1.0f, 0.0f);
	glEnd(); 

	glBegin(GL_QUADS);  //draw top face of cube
		glVertex3f(0.0f, 1.0f, 0.0f);
		glVertex3f(0.0f, 1.0f, 1.0f);
		glVertex3f(1.0f, 1.0f, 1.0f);
		glVertex3f(1.0f, 1.0f, 0.0f);
	glEnd(); 

	glBegin(GL_QUADS);  //draw bottom face of cube
		glVertex3f(0.0f, 0.0f, 0.0f);
		glVertex3f(0.0f, 0.0f, 1.0f);
		glVertex3f(1.0f, 0.0f, 1.0f);
		glVertex3f(1.0f, 1.0f, 0.0f);
	glEnd(); 
	glTranslatef(0.0f,0.0f,0.0f);
	*/

// LAST WORKING	
	glBegin(GL_QUADS);  //draw front face of cube
		glVertex3f(x - (width/2.0f), height, z);
		glVertex3f(x - (width/2.0f), height + OBSTACLE_HEIGHT, z);
		glVertex3f(x + (width/2.0f), height + OBSTACLE_HEIGHT, z);
		glVertex3f(x + (width/2.0f), height, z);	
	glEnd(); 

	
	glBegin(GL_QUADS);  //draw left side of cube
		glVertex3f(x - (width/2.0f), height, z);
		glVertex3f(x - (width/2.0f), height, z + depth);
		glVertex3f(x - (width/2.0f), height + OBSTACLE_HEIGHT, z + depth);
		glVertex3f(x - (width/2.0f), height + OBSTACLE_HEIGHT, z);	
	glEnd(); 

	glBegin(GL_QUADS);  //draw right side of cube
		glVertex3f(x + (width/2.0f), height, z);
		glVertex3f(x + (width/2.0f), height, z + depth);
		glVertex3f(x + (width/2.0f), height + OBSTACLE_HEIGHT, z + depth);
		glVertex3f(x + (width/2.0f), height + OBSTACLE_HEIGHT, z);	
	glEnd(); 

	glBegin(GL_QUADS);  //draw bottom of cube
		glVertex3f(x - (width/2.0f), height, z);
		glVertex3f(x - (width/2.0f), height, z + depth);
		glVertex3f(x + (width/2.0f), height, z + depth);
		glVertex3f(x + (width/2.0f), height, z);	
	glEnd(); 

	glBegin(GL_QUADS);  //draw top of cube
		glVertex3f(x + (width/2.0f), height + OBSTACLE_HEIGHT, z);
		glVertex3f(x + (width/2.0f), height + OBSTACLE_HEIGHT, z + depth);
		glVertex3f(x + (width/2.0f), height + OBSTACLE_HEIGHT, z + depth);
		glVertex3f(x + (width/2.0f), height + OBSTACLE_HEIGHT, z);	
	glEnd();
	
}

//function that draws the road
void glfunc :: drawRoad(float x1, float x2, int length){

	glBegin(GL_QUADS);
		glVertex3f(x1, -4, 0);
		glVertex3f(x1, -4, length);
		glVertex3f(x2, -4, length);
		glVertex3f(x2, -4, 0);	
	glEnd(); 

}

//function that renders the entire scene
void glfunc :: IBeginDrawGame(IEntVars *pVars, int trackLength){

	if ( !glTrack->bCreated )
	{
		glTrack->Create( trackLength );
//		int type = glRand->Rand() % NUM_WARPS;
		glTrack->DoWarp(RANGE,FRAC,WARP_NONE);
	}
	if ( glTrack->bCreated )
	{
		if ( glInput->isKeyPressed( GKEY_SPACE ) )
		{
			if ( glTrack->warpType == WARP_NONE )
				glTrack->DoWarp(RANGE,FRAC,WARP_AXIALSPIRAL);
			else if ( glTrack->warpType == WARP_AXIALSPIRAL )
			{
				glTrack->Create( trackLength );
				glTrack->DoWarp(RANGE,FRAC,WARP_PERPSPIRAL);
			}
			else if ( glTrack->warpType == WARP_PERPSPIRAL )
			{
				glTrack->Create( trackLength );
				glTrack->DoWarp(RANGE,FRAC,WARP_CURVY);
			}
			else if ( glTrack->warpType == WARP_CURVY )
			{
				glTrack->Create( trackLength );
				glTrack->DoWarp(RANGE,FRAC,WARP_NONE);
			}
		}
	}

	glClearColor(0.0f, 0.17f, 0.4f, 0.0f); // should be 0.6
	glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
	glLoadIdentity();
	//glClear( GL_DEPTH_BUFFER_BIT );
	
	//load in the projection matrix
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90.0f, 1.0f, 0.0f, 100.0f);  //set the perspective
	
	//load in the modelview matrix
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	//get the variables for the player entity and store them locally
	//player is for player position
	float playerX = pVars->origin.x;
	float playerY = pVars->origin.y;
	float playerZ = pVars->origin.z;

	Vec3d up;
	up = glTrack->getNormal(playerX,playerY,playerZ,RANGE,FRAC);

	if ( glTrack->bCreated )
	{
		playerX += glTrack->getXOffsetFromXYZ(pVars->origin.x, pVars->origin.y, pVars->origin.z,RANGE,FRAC);
		playerY += glTrack->getYOffsetFromXYZ(pVars->origin.x, pVars->origin.y, pVars->origin.z,RANGE,FRAC);
	}
	//view is for what position the player is looking at

	float viewX = playerX + pVars->orientation.x;
	float viewY = playerY + pVars->orientation.y;
	float viewZ = playerZ + pVars->orientation.z;

	if ( glTrack->bCreated && (glTrack->warpType == WARP_PERPSPIRAL || glTrack->warpType == WARP_AXIALSPIRAL) )
	{
		viewX = pVars->origin.x;
		viewY = pVars->origin.y;
		viewZ = pVars->origin.z + LOOK_AHEAD;
		viewX += glTrack->getXOffsetFromXYZ( pVars->origin.x, pVars->origin.y, viewZ, RANGE, FRAC );
		viewY += glTrack->getYOffsetFromXYZ( pVars->origin.x, pVars->origin.y, viewZ, RANGE, FRAC );
	}
    
	//gluLookat depends on the position and the view which is calculated every time
	// 					 Position				 View			  Up Vector
	gluLookAt(playerX, playerY, playerZ,	viewX, viewY, viewZ,	up.x,up.y,up.z);

	
	//draw the road black
	glPushMatrix();

/*		glColor3f(0.0f, 0.0f, 0.0f);
		drawRoad(TRACK_1_X + 5.0f, TRACK_1_X - 5.0f , trackLength);
		glColor3f( 0.2f,0.2f,0.2f);
		drawRoad(TRACK_2_X + 5.0f, TRACK_2_X - 5.0f , trackLength);	
		lColor3f(0.0f, 0.0f, 0.0f);
		drawRoad(TRACK_3_X + 5.0f, TRACK_3_X - 5.0f , trackLength);	
*/
		if ( glTrack->bCreated )
			glTrack->Draw();
	glPopMatrix();

	
}

//function that is called from CGameControl
//gets the entity and calls local functions to draw them
void glfunc :: IDrawEnt(IEntVars *pVars){

	//draw the specified entity
	if ( pVars->ent_flags & ENT_VISIBLE )
	{
		switch ( pVars->obj_type ) // find out what entity it is
		{
		case OBJ_OBSTACLE: // if the entity is an obstacle draw it
			drawObstacle(pVars->origin.x+glTrack->getXOffsetFromXYZ( pVars->origin.x, pVars->origin.y, pVars->origin.z,RANGE,FRAC), RADIUS_OBSTACLE, pVars->origin.y+glTrack->getYOffsetFromXYZ( pVars->origin.x, pVars->origin.y, pVars->origin.z,RANGE,FRAC), pVars->origin.z, RADIUS_OBSTACLE);
			break;
		case OBJ_COIN:  // if the entitiy is a coin draw it
			drawCoin(pVars->origin.x+glTrack->getXOffsetFromXYZ(pVars->origin.x, pVars->origin.y, pVars->origin.z,RANGE,FRAC), RADIUS_COIN, pVars->origin.y+glTrack->getYOffsetFromXYZ(pVars->origin.x, pVars->origin.y, pVars->origin.z,RANGE,FRAC), pVars->origin.z, RADIUS_COIN);
			break;
		}
	}
	
	
}

void glfunc :: IDrawInfo(IEntVars* pvars, int coins, int score, int lives )
{
	float x = 0;
	float y = 0;
	float z = 0;

	x = pvars->origin.x + glTrack->getXOffsetFromXYZ(pvars->origin.x, pvars->origin.y, pvars->origin.z,RANGE,FRAC) + pvars->orientation.x;
	y = pvars->origin.y + glTrack->getYOffsetFromXYZ(pvars->origin.x, pvars->origin.y, pvars->origin.z,RANGE,FRAC) + pvars->orientation.y;
	z = pvars->origin.z + pvars->orientation.z;
	///////////////////
	// NEHE
//	glLoadIdentity();	
//	glTranslatef(0.0f,0.0f,20.0f);						// Move One Unit Into The Screen
	// Pulsing Colors Based On Text Position
	glColor3f(0.0f,1.0f,0.0f);
	// Position The Text On The Screen
	glRasterPos3f(x-20, y+5, z+40.0f);
	glPrint("FPS2: %f",1/glTime->reportFrameInterval());	// Print GL Text To The Screen
	glRasterPos3f(x-20, y, z+40.0f);
	glPrint("Time: %f",glTime->getTime());	// Print GL Text To The Screen
	glRasterPos3f(x-20, y-5, z+40.0f);
	glPrint("-Frame: %f",glTime->getLastFrameTime());	// Print GL Text To The Screen
	glRasterPos3f(x-20, y-10, z+40.0f);
	glPrint("Delta: %f",glTime->getTime()-glTime->getLastFrameTime());	// Print GL Text To The Screen
	glRasterPos3f(x-20, y-15, z+40.0f);
	glPrint("FPS1: %f",1/(glTime->getTime()-glTime->getLastFrameTime()));	// Print GL Text To The Screen
	glRasterPos3f(x-20, y-20, z+40.0f);
	glPrint("Coins: %i",coins);	// Print GL Text To The Screen
	glRasterPos3f(x-20, y-25, z+40.0f);
	glPrint("Score: %i",score);	// Print GL Text To The Screen
	glRasterPos3f(x-20, y-30, z+40.0f);
	glPrint("Lives: %i",lives);	// Print GL Text To The Screen
	glRasterPos3f(x-20, y-35, z+40.0f);
	glPrint("Speed: %f",pvars->speed);	// Print GL Text To The Screen
	glRasterPos3f(x-20, y-40, z+40.0f);
	glPrint("Distance: %f",pvars->origin.z);	// Print GL Text To The Screen

	//
	////////////////

}

///////////////////////////////////////////////////////////
//     these two functions written by Blaine Hodge       //
//              adapted by Patrick Dwyer                 //
///////////////////////////////////////////////////////////

// Enable OpenGL

void glfunc :: EnableOpenGL(HWND hWnd, HDC * hDC, HGLRC * hRC)
{
	PIXELFORMATDESCRIPTOR pfd;
	int format;
	
	// get the device context (DC)
	*hDC = GetDC( hWnd );
	glhDC = *hDC;
	// set the pixel format for the DC
	ZeroMemory( &pfd, sizeof( pfd ) );
	pfd.nSize = sizeof( pfd );
	pfd.nVersion = 1;
	pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
	pfd.iPixelType = PFD_TYPE_RGBA;
	pfd.cColorBits = 24;
	pfd.cDepthBits = 16;
	pfd.iLayerType = PFD_MAIN_PLANE;
	format = ChoosePixelFormat( *hDC, &pfd );
	SetPixelFormat( *hDC, format, &pfd );
	
	// create and enable the render context (RC)
	*hRC = wglCreateContext( *hDC );
	wglMakeCurrent( *hDC, *hRC );
	
	BuildFont();
	glTrack = new GTrackArray;

	glClearDepth(1.0);									// Enables Clearing Of The Depth Buffer
	glDepthFunc(GL_LESS);								// The Type Of Depth Test To Do
	//glEnable(GL_DEPTH_TEST);
}

// Disable OpenGL

void glfunc :: DisableOpenGL(HWND hWnd, HDC hDC, HGLRC hRC)
{
	KillFont();
	wglMakeCurrent( NULL, NULL );
	wglDeleteContext( hRC );
	ReleaseDC( hWnd, hDC );
}
// END CODE WRITTEN BY Blaine Hodge
////////////////////////////////////////////////////////


//////////////////////////////////
// NEHE CODE

GLvoid BuildFont(GLvoid)								// Build Our Bitmap Font
{
	HFONT	font;										// Windows Font ID
	HFONT	oldfont;									// Used For Good House Keeping

	base = glGenLists(96);								// Storage For 96 Characters

	font = CreateFont(	-24,							// Height Of Font
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_BOLD,						// Font Weight
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						"Courier New");					// Font Name

	oldfont = (HFONT)SelectObject(glhDC, font);           // Selects The Font We Want
	wglUseFontBitmaps(glhDC, 32, 96, base);				// Builds 96 Characters Starting At Character 32
	SelectObject(glhDC, oldfont);							// Selects The Font We Want
	DeleteObject(font);									// Delete The Font
}

GLvoid KillFont(GLvoid)									// Delete The Font List
{
	glDeleteLists(base, 96);							// Delete All 96 Characters
}

GLvoid glPrint(const char *fmt, ...)					// Custom GL "Print" Routine
{
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(base - 32);								// Sets The Base Character to 32
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}

