#ifndef __SOUNDFUNC_H_
#define __SOUNDFUNC_H_

#include "CBaseEntity.h"
#include "IEntVars.h"

//--------------------------------------------------------
//	sound/FMOD functions
//
// .. these are the sound engine functions
//
//	UPDATES:
//		- 2/9/04, Daniel: very rough outline. take it away
//		- 2/22/04, Eden: finalized, IInitializeSounds, etc.
//		- 2/22/04, Daniel: Initsounds needs entCount
//
//--------------------------------------------------------

const int SOUND_EVENT_HITOBSTACLE			= 0;
const int SOUND_EVENT_HITCOIN				= 1;
const int SOUND_EVENT_DEATH					= 2;
const int SOUND_EVENT_LEVELSTART			= 3;
const int SOUND_EVENT_LEVELEND				= 4;
const int SOUND_EVENT_PAUSE					= 5;
const int SOUND_EVENT_DONEMOVING			= 6;
const int SOUND_EVENT_WARNING				= 7;
const int SOUND_EVENT_LEFTLANE				= 8;
const int SOUND_EVENT_CENTERLANE			= 9;
const int SOUND_EVENT_RIGHTLANE				= 10;
const int SOUND_EVENT_UNPAUSE				= 11;

const int SOUND_MENU_TRAINING				= 20;
const int SOUND_MENU_STARTGAME				= 21;
const int SOUND_MENU_HIGHSCORES				= 22;
const int SOUND_MENU_QUIT					= 23;
const int SOUND_MENU_SONICZOOM				= 24;
const int SOUND_MENU_INSTRUCTIONS			= 25;

const int SOUND_STREAM_TRAINING				= 30;
const int SOUND_STREAM_CREDITS				= 31;
const int SOUND_STREAM_MUSIC				= 32;

const int SOUND_3D_MOVING					= 40;					



// for alpha...
void IInitializeMenuSounds();
void IPlayMenuSound( int type );
void IInitializeRaceSounds( CBaseEntity** entArray, int entCount );
void IResetRaceSounds( CBaseEntity** entArray, int entCount );
void IUpdateSounds( CBaseEntity** entArray, int entCount, IEntVars * player );
void IPlayStationarySound( float pos[3], int volume, int type );
void IPlay3DSound( float pos[3], float vel[3], int volume, int type );
void IPauseSounds();
void IUnpauseSounds();
void IResetSounds();
void IFreeRacingSamples();
void IFreeMenuSamples();
void ICloseFmod();




#endif