
#ifndef __GLFUNC_H_
#define __GLFUNC_H_

#include <windows.h>
#include "IEntVars.h"
#include "stateflagdefs.h"
#include "globalconst.h"
#include "glaux.h"
#include <gl/gl.h>
#include <gl/glu.h>

//--------------------------------------------------------
//	openGL functions
//
// .. these are the engine functions
//
//	UPDATES:
//		- 2/9/04, Daniel: very rough outline. take it away
//      - 2/22/04 Patrick: worked out some basic functions
//
//--------------------------------------------------------


class glfunc
{
public:
	glfunc();  //constructor
	void EnableOpenGL(HWND hWnd, HDC * hDC, HGLRC * hRC); // enable openGL
	void DisableOpenGL(HWND hWnd, HDC hDC, HGLRC hRC);  // disable openGL
	void init(); // initializes depth test

	void IBeginDrawGame(IEntVars *pVars, int trackLength);  //Sets up the camera and the scene to be drawn
	void drawRoad(float x1, float x2, int length);  //draw the road

	void IDrawEnt(IEntVars *pVars);  //function that takes in entity and uses following functions to draw them
	void drawObstacle(float x, float width, float height, float z, float depth); //draw the obstacle
	void drawCoin(float x, float width, float height, float z, float depth); //draw coin
	void IDrawInfo( IEntVars* pvars, int coins, int score, int lives);


};

GLvoid BuildFont(GLvoid);
GLvoid KillFont(GLvoid);
GLvoid glPrint(const char *fmt, ...);
/*
// for alpha
void IBeginDrawGame();
void IEndDrawGame();
void IDrawEnt( IEntVars *pEnt );
*/
// and beyond..

/* exact specs for these not set yet (we may create an IGameVars object, for instance, for some HUD things...)
IBeginDrawGame()
IBeginDrawMenu()
IDrawEnt( IEntVars *pent )
IDrawMenuItem()
IEndDrawGame()
IEndDrawMenu()
IDrawPause()
IDrawLoading()
IDrawLevelDeath()
IDrawLevelSuccess()
*/




#endif