
#ifndef __STATEFLAGDEFS_H_
#define __STATEFLAGDEFS_H_

//-------------------------------------
//	state/flag definitions
//
// ... coded by everyone, as needed
//
//	UPDATES:
//		- 2/7/04, Daniel: Created, game/object/player first pass
//		- 2/9/04, Daniel: object types
//		- 2/11/04, Daniel: players need flags, not states. doh.
//
//-------------------------------------

// EXISTENTIAL STATES (highest level)
const int EX_QUIT			= 0;
const int EX_MENU_INTRO		= 1;
const int EX_MENU_INIT		= 2;
const int EX_MENU			= 3;
const int EX_GAME_INIT		= 4;
const int EX_GAME			= 5;
 

// GAME STATE
const int GAME_INIT			= 0;
const int GAME_LEVELINIT	= 1;
const int GAME_STARTING		= 2;
const int GAME_RACING		= 3;
const int GAME_PAUSE		= 4;
const int GAME_LEVEL_SUCCESS = 5;
const int GAME_HIGHSCORES	= 6;
const int GAME_DEATH		= 7;
const int GAME_QUIT			= 8;

// MENU STATES
const int MENU_INTRO		= 0;
const int MENU_INIT			= 1;
const int MENU_SELECTING	= 2;
const int MENU_GAMESELECT	= 3;
const int MENU_HIGHSCORES	= 4;
const int MENU_DOTRAINING	= 5;
const int MENU_DOGAMEPLAY	= 6;
const int MENU_DOQUIT		= 7;

// MENU CHOICES
const int MENU_SELECT_TRAINING		= 0;
const int MENU_SELECT_STARTGAME		= 1;
const int MENU_SELECT_HIGHSCORES	= 2;
const int MENU_SELECT_QUIT			= 3;

// OBJECT TYPE
const int OBJ_NONE			= 0;
const int OBJ_PLAYER		= 1;
const int OBJ_COIN			= 2;
const int OBJ_OBSTACLE		= 3;
const int OBJ_CAMERA		= 4;

// LINE COMMANDS
const int COM_NOT			= 0;
const int COM_LINE			= 1;
const int COM_REPEAT		= 2;
const int COM_CLEAR			= 3;

// ENTITY FLAGS
const int ENT_COLLIDABLE	= 1;
const int ENT_AUDIBLE		= 2;
const int ENT_VISIBLE		= 4;
const int ENT_MOVABLE		= 8;
const int ENT_MOVING		= 16;
const int ENT_PLAYER		= 32;
const int ENT_DEAD			= 64; // dead things don't think

// PLAYER FLAGS
const int PL_NOT_PLAYER			= 0;
const int PL_ACCELERATING		= 1;
const int PL_STRAIGHTAWAY		= 3;
const int PL_HIT				= 4;
const int PL_STUNNED			= 5;
const int PL_DEAD				= 7;

// SWITCH FLAGS
const int SWITCH_NO				= 0;
const int SWITCH_LEFT			= 1;
const int SWITCH_RIGHT			= 2;

// CAMERA STUFF
const int CAMSTATE_INIT			= 0;
const int CAMSTATE_ACTIVE		= 1;
const int CAMSTATE_DEAD			= 2;

const int CAMTYPE_STARTER		= 0;
const int CAMTYPE_OVERLOOK		= 1;

const int NUM_CAMTYPES			= 2;






#endif